;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname battleship-universe) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #t #t none #f ())))
(require 2htdp/universe)

;; A game-mode is
;;   - 'waiting-1
;;   - 'waiting-2
;;   - 'turn-1
;;   - 'response-for-1-from-2
;;   - 'turn-2
;;   - 'response-for-2-from-1

;; A sea is
;;  (make-sea game-mode iworld-or-false iworld-or-false)
(define-struct sea (mode world-1 world-2))

;; add-world : sea iworld -> bundle
(define (add-world s w)
  (cond
    [(eq? (sea-mode s) 'waiting-1)
     (make-bundle (make-sea 'waiting-2
                            w
                            false)
                  empty
                  empty)]
    [(eq? (sea-mode s) 'waiting-2)
     (make-bundle (make-sea 'turn-1
                            (sea-world-1 s)
                            w)
                  (list (make-mail (sea-world-1 s) 'go))
                  empty)]
    [else
     (error "too many players")]))

(check-expect (add-world (make-sea 'waiting-1 false false)
                         iworld1)
              (make-bundle (make-sea 'waiting-2 iworld1 false)
                           empty
                           empty))
(check-expect (add-world (make-sea 'waiting-2 iworld1 false)
                         iworld2)
              (make-bundle (make-sea 'turn-1 iworld1 iworld2)
                           (list (make-mail iworld1 'go))
                           empty))

;; change-turn : sea msg mode -> sea
(define (change-turn s msg mode)
  (make-bundle (make-sea mode
                         (sea-world-1 s)
                         (sea-world-2 s))
               (list (make-mail (if (eq? mode 'turn-2)
                                    (sea-world-1 s) 
                                    (sea-world-2 s))
                                msg)
                     (make-mail (if (eq? mode 'turn-2)
                                    (sea-world-2 s) 
                                    (sea-world-1 s))
                                'go))
               empty))

(check-expect (change-turn (make-sea 'response-for-1-from-2 iworld1 iworld2)
                           'miss
                           'turn-2)
              (make-bundle (make-sea 'turn-2 iworld1 iworld2)
                           (list (make-mail iworld1 'miss)
                                 (make-mail iworld2 'go))
                           empty))
(check-expect (change-turn (make-sea 'response-for-2-from-1 iworld1 iworld2)
                           3
                           'turn-1)
              (make-bundle (make-sea 'turn-1 iworld1 iworld2)
                           (list (make-mail iworld2 3)
                                 (make-mail iworld1 'go))
                           empty))

;; response? : s-exp -> boolean
(define (response? v) (or (eq? v 'hit) (eq? v 'miss) (number? v)))

;; fire-msg? : s-exp -> boolean
(define (fire-msg? msg)
  (and (list? msg)
       (= 3 (length msg))
       (eq? 'fire (first msg))
       (number? (second msg))
       (number? (third msg))))

(check-expect (fire-msg? 0) false)
(check-expect (fire-msg? 'fire) false)
(check-expect (fire-msg? '(fire 0)) false)
(check-expect (fire-msg? '(fire 0 fire)) false)
(check-expect (fire-msg? '(fire 0 1)) true)

;; waiting-for-response : sea s-exp sea-mode -> bundle
;;  Sends s-exp message to the player indicated by the new mode,
;;  updates the mode; assumes we have two players
(define (waiting-for-response s msg new-mode)
  (make-bundle (make-sea new-mode (sea-world-1 s) (sea-world-2 s))
               (list (make-mail (if (eq? (sea-mode s) 'turn-1)
                                    (sea-world-2 s)
                                    (sea-world-1 s))
                                msg))
               empty))

(check-expect (waiting-for-response (make-sea 'turn-1 iworld1 iworld2)
                                    '(fire 0 1)
                                    'response-for-1-from-2)
              (make-bundle (make-sea 'response-for-1-from-2 iworld1 iworld2)
                           (list (make-mail iworld2 '(fire 0 1)))
                           empty))
(check-expect (waiting-for-response (make-sea 'turn-2 iworld1 iworld2)
                                    '(fire 0 1)
                                    'response-for-2-from-1)
              (make-bundle (make-sea 'response-for-2-from-1 iworld1 iworld2)
                           (list (make-mail iworld1 '(fire 0 1)))
                           empty))

;; take-turn : sea iworld sexp -> bundle
(define (take-turn s w msg)
  (cond
    [(and (eq? (sea-mode s) 'turn-1)
          (iworld=? w (sea-world-1 s))
          (fire-msg? msg))
     (waiting-for-response s msg 'response-for-1-from-2)]
    [(and (eq? (sea-mode s) 'turn-2)
          (iworld=? w (sea-world-2 s))
          (fire-msg? msg))
     (waiting-for-response s msg 'response-for-2-from-1)]
    [(and (eq? (sea-mode s) 'response-for-1-from-2)
          (iworld=? w (sea-world-2 s))
          (response? msg))
     (change-turn s msg 'turn-2)]
    [(and (eq? (sea-mode s) 'response-for-2-from-1)
          (iworld=? w (sea-world-1 s))
          (response? msg))
     (change-turn s msg 'turn-1)]
    [else
     (error "bad message")]))

(check-expect (take-turn (make-sea 'turn-1 iworld1 iworld2)
                         iworld1
                         '(fire 0 1))
              (waiting-for-response (make-sea 'turn-1 iworld1 iworld2)
                                    '(fire 0 1)
                                    'response-for-1-from-2))
(check-expect (take-turn (make-sea 'turn-2 iworld1 iworld2)
                         iworld2
                         '(fire 0 1))
              (waiting-for-response (make-sea 'turn-2 iworld1 iworld2)
                                    '(fire 0 1)
                                    'response-for-2-from-1))

(universe
 (make-sea 'waiting-1 false false)
 [on-new add-world]
 [on-msg take-turn])
